# remirepo/fedora spec file for php-morris-lessql
#
# Copyright (c) 2016-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    f4150517f6492a761ed1ccb8dd180769e1f89e54
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     morris
#global gh_date      20150820
%global gh_project   lessql
%global with_tests   0%{!?_without_tests:1}
%global psr0         LessQL

Name:           php-%{gh_owner}-%{gh_project}
Version:        0.4.1
Release:        1%{?gh_date?%{gh_date}git%{gh_short}}%{?dist}
Summary:        The agile PHP ORM alternative

License:        MIT
URL:            http://lessql.net/
Source0:        https://github.com/%{gh_owner}/%{gh_project}/archive/%{gh_commit}/%{name}-%{version}-%{?gh_short}.tar.gz

BuildArch:      noarch
%if %{with_tests}
BuildRequires:  php(language) >= 5.3.4
BuildRequires:  php-json
BuildRequires:  php-pcre
BuildRequires:  php-spl
# For tests, from composer.json 	"require-dev": {
#		"phpunit/phpunit": "~4.6|~5|~6|~7",
#		"codeclimate/php-test-reporter": "dev-master"
%if 0%{?fedora} >= 28 || 0%{?rhel} >= 8
%global phpunit %{_bindir}/phpunit7
%else
%global phpunit %{_bindir}/phpunit
%endif
BuildRequires:  %{phpunit}
BuildRequires:  php-pdo
BuildRequires:  php-date
%endif
# For autoloader
BuildRequires:  php-composer(theseer/autoload)

# From composer.json, 	"require": {
#		"php": ">=5.3.4"
Requires:       php(language) >= 5.3.4
# From phpcompatinfo report for 0.3.4
Requires:       php-json
Requires:       php-pcre
Requires:       php-spl

# Composer
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
LessQL is a lightweight and performant alternative to Object-Relational
Mapping for PHP.

Autoloader: %{_datadir}/php/%{psr0}/autoload.php


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: generate an simple autoloader
%{_bindir}/phpab --output src/%{psr0}/autoload.php src/%{psr0}


%install
: Library
mkdir -p           %{buildroot}%{_datadir}/php
cp -pr src/%{psr0} %{buildroot}%{_datadir}/php/%{psr0}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require '%{buildroot}%{_datadir}/php/%{psr0}/autoload.php';
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" "php70 %{_bindir}/phpunit" php71 php72 php73; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --no-coverage tests || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE.md
%doc composer.json
%doc CHANGELOG.md
%doc README.md
%{_datadir}/php/%{psr0}


%changelog
* Mon May  6 2019 Remi Collet <remi@remirepo.net> - 0.4.1-1
- update to 0.4.1

* Mon Jan 29 2018 Remi Collet <remi@remirepo.net> - 0.3.5-1
- Update to 0.3.5

* Tue Sep 27 2016 Remi Collet <remi@fedoraproject.org> - 0.3.4-1
- initial package

